diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/head.S ./arch/ppc/kernel/head.S
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/head.S	Wed May 12 09:56:44 1999
+++ ./arch/ppc/kernel/head.S	Sun May 16 12:01:08 1999
@@ -41,6 +41,19 @@
 #include <asm/amigappc.h>
 #endif
 
+#if 1
+#define APUS_PROGRESS(_a)
+#else
+#define APUS_PROGRESS(_a)			\
+	lis	r3,0xfff0;			\
+	ori	r3,r3,0xeff0;			\
+	lis	r4,0x1234;			\
+	ori	r4,r4,(_a);			\
+	stw	r4,0x0(r3);			\
+	dcbf	0,r3;				\
+	sync;					\
+	isync
+#endif
 /* optimization for 603 to load the tlb directly from the linux table */
 #define NO_RELOAD_HTAB 1
 	
@@ -103,27 +116,27 @@
 	lwz	RB,offset+4(reg);	\
 	mtspr	IBAT##n##U,RA;	\
 	mtspr	IBAT##n##L,RB;	\
-	beq	1f;		\
+	beq	0f;		\
 	lwz	RA,offset+8(reg);	\
 	lwz	RB,offset+12(reg);	\
 	mtspr	DBAT##n##U,RA;	\
 	mtspr	DBAT##n##L,RB;	\
-1:	 
+0:	 
+
+#define tophys(rd,rs)				\
+0:	addis	rd,rs,-KERNELBASE@h;		\
+	.section ".vtop_fixup","aw";		\
+	.align  1;				\
+	.long   0b;				\
+	.previous
+
+#define tovirt(rd,rs)				\
+0:	addis	rd,rs,KERNELBASE@h;		\
+	.section ".ptov_fixup","aw";		\
+	.align  1;				\
+	.long   0b;				\
+	.previous
 
-#ifndef CONFIG_APUS
-#define tophys(rd,rs,rt)	addis	rd,rs,-KERNELBASE@h
-#define tovirt(rd,rs,rt)	addis	rd,rs,KERNELBASE@h
-#else
-#define tophys(rd,rs,rt)	 \
-	lis	rt,CYBERBASEp@h; \
-	lwz	rt,0(rt);	 \
-	add	rd,rs,rt
-#define tovirt(rd,rs,rt)	 \
-	lis	rt,CYBERBASEp@h; \
-	lwz	rt,0(rt);	 \
-	sub	rd,rs,rt
-#endif
-	
 	.text
 	.globl	_stext
 _stext:
@@ -154,6 +167,7 @@
  *
  * APUS
  *   r3: 'APUS'
+ *   r4: physical address of memory base
  *   Linux/m68k style BootInfo structure at &_end.
  *
  * PREP
@@ -221,6 +235,16 @@
 	bl	prom_init
 	.globl	__secondary_start
 __secondary_start:
+/* On APUS the __va/__pa constants need to be set to the correct 
+ * values before continuing. 
+ */
+	lis	r3,0x6170
+	ori	r3,r3,0x7573
+	cmpw	4,r3,r31		/* cr4.eq is true if this is APUS */
+	bne	4,1f
+	mr	r4,r30
+	bl	fix_mem_constants
+1:
 /*
  * Use the first pair of BAT registers to map the 1st 16MB
  * of RAM to KERNELBASE.  From this point on we can't safely
@@ -241,16 +265,17 @@
 	mtspr	IBAT1L,r10
 	b	5f
 4:
-#ifdef CONFIG_APUS
-	ori	r11,r11,BL_8M<<2|0x2	/* set up an 8MB mapping */
-	ori	r11,r11,0xfe		/* set up an 8MB mapping */
-	lis	r8,CYBERBASEp@h
-	lwz	r8,0(r8)
-	addis	r8,r8,KERNELBASE@h
-	addi	r8,r8,2
-#else
+	tophys(r8,r11)                  /* phys memory base */
+	ori	r8,r8,2			/* R/W access */
+	beq	4,1f                    /* only set up 8MB on APUS */
 	ori	r11,r11,BL_256M<<2|0x2	/* set up BAT registers for 604 */
-	li	r8,2			/* R/W access */
+1:	ori	r11,r11,BL_8M<<2|0x2	/* set up 8MB BAT registers for 604 */
+	mtspr	DBAT0L,r8		/* N.B. 6xx (not 601) have valid */
+	mtspr	DBAT0U,r11		/* bit in upper BAT register */
+	mtspr	IBAT0L,r8
+	mtspr	IBAT0U,r11
+
+#ifndef CONFIG_APUS		        /* out of space! :( */
 	/* 
 	 * allow secondary cpus to get at all of ram in early bootup
 	 * since their init_task may be up there -- Cort
@@ -269,33 +294,8 @@
 	mtspr	IBAT2L,r28
 	mtspr	IBAT2U,r21
 #endif
-	mtspr	DBAT0L,r8		/* N.B. 6xx (not 601) have valid */
-	mtspr	DBAT0U,r11		/* bit in upper BAT register */
-	mtspr	IBAT0L,r8
-	mtspr	IBAT0U,r11
 5:	isync
 
-#ifdef CONFIG_APUS
-	/* Unfortunately the APUS specific instructions bloat the
-	 * code so it cannot fit in the 0x100 bytes available. We have
-	 * to do it the crude way. */
-
-	/* Map 0xfff00000 so we can access VTOP/PTOV constant when
-	   MMU is enabled. */
-	lis	r8,0xfff0
-	ori	r11,r8,0x2		/* r/w */
-	ori	r8,r8,0x2		/* 128KB, supervisor */
-	mtspr	DBAT3U,r8
-	mtspr	DBAT3L,r11
-	
-	/* Copy exception code to exception vector base. */
-	lis	r3,KERNELBASE@h
-	tophys(r4,r3,r5)
-	lis	r3,0xfff0		/* Copy to 0xfff00000 on APUS */
-	li	r5,0x4000		/* # bytes of memory to copy */
-	li	r6,0
-	bl	copy_and_flush		/* copy the first 0x4000 bytes */
-#else /* CONFIG_APUS */
 /*
  * We need to run with _start at physical address 0.
  * On CHRP, we are loaded at 0x10000 since OF on CHRP uses
@@ -304,6 +304,7 @@
  * If the MMU is already turned on, we copy stuff to KERNELBASE,
  * otherwise we copy it to 0.
  */
+	beq	4,2f                    /* skip this on APUS */
 	bl	reloc_offset
 	mr	r26,r3
 	addis	r4,r3,KERNELBASE@h	/* current address of _start */
@@ -317,7 +318,7 @@
 	cmpw	0,r4,r3			/* already running at KERNELBASE? */
 	bne	relocate_kernel
 2:
-#endif /* CONFIG_APUS */
+
 /*
  * we now have the 1st 16M of ram mapped with the bats.
  * prep needs the mmu to be turned on here, but pmac already has it on.
@@ -430,7 +431,7 @@
 	mfspr	r21,SPRG2;		/* exception stack to use from */ \
 	cmpwi	0,r21,0;		/* user mode or RTAS */ \
 	bne	1f;		\
-	tophys(r21,r1,r21);		/* use tophys(kernel sp) otherwise */ \
+	tophys(r21,r1);			/* use tophys(kernel sp) otherwise */ \
 	subi	r21,r21,INT_FRAME_SIZE+STACK_UNDERHEAD;	/* alloc exc. frame */\
 1:	stw	r20,_CCR(r21);		/* save registers */ \
 	stw	r22,GPR22(r21);	\
@@ -451,7 +452,7 @@
 	stw	r1,GPR1(r21);	\
 	stw	r2,GPR2(r21);	\
 	stw	r1,0(r21);	\
-	tovirt(r1,r21,r1);		/* set new kernel sp */	\
+	tovirt(r1,r21);			/* set new kernel sp */	\
 	SAVE_4GPRS(3, r21);
 /*
  * Note: code which follows this uses cr0.eq (set if from kernel),
@@ -535,44 +536,18 @@
 	.long	int_return
 
 /* External interrupt */
-	. = 0x500;
+	. = 0x500
 HardwareInterrupt:
 	EXCEPTION_PROLOG;
-#ifdef CONFIG_APUS
-	/* This is horrible, but there's no way around it. Enable the
-	data cache so the IRQ hardware register can be accessed
-	without cache intervention. Then disable interrupts and get
-	the current emulated m68k IPL value. */
-	
-	mfmsr	20
-	xori	r20,r20,MSR_DR
-	sync
-	mtmsr	r20
-	sync
 
-	lis	r3,APUS_IPL_EMU@h
-
-	li	r20,(IPLEMU_SETRESET|IPLEMU_DISABLEINT)
-	stb	r20,APUS_IPL_EMU@l(r3)
-	eieio
-
-	lbz	r3,APUS_IPL_EMU@l(r3)
-
-	mfmsr	r20
-	xori	r20,r20,MSR_DR
-	sync
-	mtmsr	r20
-	sync
-
-	stw	r3,(_CCR+4)(r21);
-#endif
 	addi	r3,r1,STACK_FRAME_OVERHEAD
 	li	r20,MSR_KERNEL
-	li	r4,0
-	bl	transfer_to_handler
-	.long	do_IRQ;
+apusIRQ:	
+	bl	transfer_to_handler         /* On APUS these three words */
+	.long	do_IRQ                      /* will be replaced with NOPs */
 	.long	int_return
-	
+
+	bl	apus_interrupt_entry
 
 /* Alignment exception */
 	. = 0x600
@@ -655,13 +630,13 @@
 	/* Get PTE (linux-style) and check access */
 	mfspr	r2,SPRG3
 	lwz	r2,PG_TABLES(r2)
-	tophys(r2,r2,r3)
+	tophys(r2,r2)
 	mfspr	r3,IMISS
 	rlwimi	r2,r3,12,20,29		/* insert top 10 bits of address */
 	lwz	r2,0(r2)		/* get pmd entry */
 	rlwinm.	r2,r2,0,0,19		/* extract address of pte page */
 	beq-	InstructionAddressInvalid	/* return if no mapping */
-	tophys(r2,r2,r1)
+	tophys(r2,r2)
 	rlwimi	r2,r3,22,20,29		/* insert next 10 bits of address */
 	lwz	r1,0(r2)		/* get linux-style pte */
 	/* setup access flags in r3 */
@@ -758,13 +733,13 @@
 	/* Get PTE (linux-style) and check access */
 	mfspr	r2,SPRG3
 	lwz	r2,PG_TABLES(r2)		
-	tophys(r2,r2,r3)
+	tophys(r2,r2)
 	mfspr	r3,DMISS
 	rlwimi	r2,r3,12,20,29		/* insert top 10 bits of address */
 	lwz	r2,0(r2)		/* get pmd entry */
 	rlwinm.	r2,r2,0,0,19		/* extract address of pte page */
 	beq-	DataAddressInvalid	/* return if no mapping */
-	tophys(r2,r2,r1)
+	tophys(r2,r2)
 	rlwimi	r2,r3,22,20,29		/* insert next 10 bits of address */
 	lwz	r1,0(r2)		/* get linux-style pte */
 	/* setup access flags in r3 */
@@ -865,7 +840,7 @@
 	/* We have a pte table, so load the MI_TWC with the attributes
 	 * for this page, which has only bit 31 set.
 	 */
-	tophys(r21,r21,0)
+	tophys(r21,r21)
 	ori	r21,r21,1		/* Set valid bit */
 	mtspr	MI_TWC, r21	/* Set page attributes */
 	mtspr	MD_TWC, r21	/* Load pte table base address */
@@ -920,13 +895,13 @@
 	/* Get PTE (linux-style) and check access */
 	mfspr	r2,SPRG3
 	lwz	r2,PG_TABLES(r2)		
-	tophys(r2,r2,r3)
+	tophys(r2,r2)
 	mfspr	r3,DMISS
 	rlwimi	r2,r3,12,20,29		/* insert top 10 bits of address */
 	lwz	r2,0(r2)		/* get pmd entry */
 	rlwinm.	r2,r2,0,0,19		/* extract address of pte page */
 	beq-	DataAddressInvalid	/* return if no mapping */
-	tophys(r2,r2,r1)
+	tophys(r2,r2)
 	rlwimi	r2,r3,22,20,29		/* insert next 10 bits of address */
 	lwz	r1,0(r2)		/* get linux-style pte */
 	/* setup access flags in r3 */
@@ -988,7 +963,7 @@
 
 	/* We have a pte table, so load fetch the pte from the table.
 	 */
-	tophys(r21, r21, 0)
+	tophys(r21, r21)
 	ori	r21, r21, 1	/* Set valid bit in physical L2 page */
 	mtspr	MD_TWC, r21	/* Load pte table base address */
 	mfspr	r21, MD_TWC	/* ....and get the pte address */
@@ -1072,7 +1047,7 @@
 
 	/* We have a pte table, so fetch the pte from the table.
 	 */
-	tophys(r21, r21, 0)
+	tophys(r21, r21)
 	ori	r21, r21, 1		/* Set valid bit in physical L2 page */
 	mtspr	MD_TWC, r21		/* Load pte table base address */
 	mfspr	r21, MD_TWC		/* ....and get the pte address */
@@ -1178,7 +1153,7 @@
 	addi	r24,r1,STACK_FRAME_OVERHEAD
 	stw	r24,PT_REGS(r23)
 2:	addi	r2,r23,-TSS		/* set r2 to current */
-	tovirt(r2,r2,r23)
+	tovirt(r2,r2)
 	mflr	r23
 	andi.	r24,r23,0x3f00		/* get vector offset */
 	stw	r24,TRAP(r21)
@@ -1246,7 +1221,7 @@
 	eieio
 	lis	r2,hash_table_lock@h
 	ori	r2,r2,hash_table_lock@l
-	tophys(r2,r2,r6)
+	tophys(r2,r2)
 	lis	r6,100000000@h
 	mtctr	r6
 	lwz	r0,PROCESSOR-TSS(r5)
@@ -1263,7 +1238,7 @@
 #endif
 	/* Get PTE (linux-style) and check access */
 	lwz	r5,PG_TABLES(r5)		
-	tophys(r5,r5,r2)		/* convert to phys addr */
+	tophys(r5,r5)			/* convert to phys addr */
 	rlwimi	r5,r3,12,20,29		/* insert top 10 bits of address */
 	lwz	r5,0(r5)		/* get pmd entry */
 	rlwinm.	r5,r5,0,0,19		/* extract address of pte page */
@@ -1276,7 +1251,7 @@
 	   to the address following the rfi. */
 	beqlr-
 #endif
-	tophys(r2,r5,r2)
+	tophys(r2,r5)
 	rlwimi	r2,r3,22,20,29		/* insert next 10 bits of address */
 	lwz	r6,0(r2)		/* get linux-style pte */
 	ori	r4,r4,1			/* set _PAGE_PRESENT bit in access */
@@ -1384,7 +1359,7 @@
 	/* update counter of evicted pages */
 	lis	r2,htab_evicts@h
 	ori	r2,r2,htab_evicts@l
-	tophys(r2,r2,r4)
+	tophys(r2,r2)
 	lwz	r4,0(r2)
 	addi	r4,r4,1
 	stw	r4,0(r2)
@@ -1439,14 +1414,14 @@
  */
 	lis	r2,htab_reloads@h
 	ori	r2,r2,htab_reloads@l
-	tophys(r2,r2,r3)
+	tophys(r2,r2)
 	lwz	r3,0(r2)
 	addi	r3,r3,1
 	stw	r3,0(r2)
 
 #ifdef __SMP__
 	lis	r2,hash_table_lock@ha
-	tophys(r2,r2,r6)
+	tophys(r2,r2)
 	li	r0,0
 	stw	r0,hash_table_lock@l(r2)
 	eieio
@@ -1473,7 +1448,7 @@
 #ifdef __SMP__
 hash_page_out:
 	lis	r2,hash_table_lock@ha
-	tophys(r2,r2,r6)
+	tophys(r2,r2)
 	li	r0,0
 	stw	r0,hash_table_lock@l(r2)
 	eieio
@@ -1506,12 +1481,8 @@
  * to another.  Instead we call giveup_fpu in switch_to.
  */
 #ifndef __SMP__
-#ifndef CONFIG_APUS
-	lis	r6,-KERNELBASE@h
-#else
-	lis	r6,CYBERBASEp@h
-	lwz	r6,0(r6)
-#endif
+	lis	r6,0                    /* get __pa constant */
+	tophys(r6,r6)
 	addis	r3,r6,last_task_used_math@ha
 	lwz	r4,last_task_used_math@l(r3)
 	cmpi	0,r4,0
@@ -1662,14 +1633,164 @@
 	addi	r6,r6,4
 	blr
 
-#ifdef CONFIG_APUS
-	/* On APUS the first 0x4000 bytes of the kernel	will be mapped
-	 * at a different physical address than the rest. For this
-	 * reason, the exception code cannot use relative branches to
-	 * access the code below.
+/*
+ * On APUS the physical base address of the kernel is not known at compile
+ * time, which means the __pa/__va constants used are incorect. In the
+ * __init section is recorded the virtual addresses of instructions using
+ * these constants, so all that has to be done is fix these before
+ * continuing the kernel boot.
+ *
+ * r4 = The physical address of the kernel base.
+ */
+fix_mem_constants:
+	mr	r10,r4
+	addis	r10,r10,-KERNELBASE@h    /* virt_to_phys constant */
+	neg	r11,r10	                 /* phys_to_virt constant */
+
+ 	APUS_PROGRESS(2)
+
+	lis	r12,__vtop_table_begin@h
+	ori	r12,r12,__vtop_table_begin@l
+	add	r12,r12,r10	         /* table begin phys address */
+	lis	r13,__vtop_table_end@h
+	ori	r13,r13,__vtop_table_end@l
+	add	r13,r13,r10	         /* table end phys address */
+	subi	r12,r12,4
+	subi	r13,r13,4
+1:	lwzu	r14,4(r12)               /* virt address of instruction */
+	add     r14,r14,r10              /* phys address of instruction */
+	lwz     r15,0(r14)               /* instruction, now insert top */
+	rlwimi  r15,r10,16,16,31         /* half of vp const in low half */
+	stw	r15,0(r14)               /* of instruction and restore. */
+	dcbst	r0,r14			 /* write it to memory */
+	sync
+	icbi	r0,r14			 /* flush the icache line */
+	cmpw	r12,r13
+	bne     1b
+
+ 	APUS_PROGRESS(3)
+
+	lis	r12,__ptov_table_begin@h
+	ori	r12,r12,__ptov_table_begin@l
+	add	r12,r12,r10	         /* table begin phys address */
+	lis	r13,__ptov_table_end@h
+	ori	r13,r13,__ptov_table_end@l
+	add	r13,r13,r10	         /* table end phys address */
+	subi	r12,r12,4
+	subi	r13,r13,4
+1:	lwzu	r14,4(r12)               /* virt address of instruction */
+	add     r14,r14,r10              /* phys address of instruction */
+	lwz     r15,0(r14)               /* instruction, now insert top */
+	rlwimi  r15,r11,16,16,31         /* half of pv const in low half*/
+	stw	r15,0(r14)               /* of instruction and restore. */
+	dcbst	r0,r14			 /* write it to memory */
+	sync
+	icbi	r0,r14			 /* flush the icache line */
+	cmpw	r12,r13
+	bne     1b
+
+ 	APUS_PROGRESS(4)
+	/*
+	 * Let Hardware Interrupts fall through to APUS specific 
+	 * handling.
 	 */
-	. = 0x4000
+	lis	r12,apusIRQ@h
+	ori	r12,r12,apusIRQ@l
+	add	r12,r12,r10              /* phys address of instructions */
+	lis     r8,0x38600000@h
+	ori     r8,r8,0x38600000@l
+	stw	r8,0(r12)
+	stwu	r8,4(r12)
+	stwu	r8,4(r12)
+	dcbst	r0,r12			 /* write it to memory */
+	sync
+	icbi	r0,r12			 /* flush the icache line */
+	subi	r12,r12,8
+	dcbst	r0,r12			 /* write it to memory */
+	sync
+	icbi	r0,r12			 /* flush the icache line */
+
+ 	APUS_PROGRESS(5)
+	
+	/*
+	 * Map the memory where the exception handlers will
+  	 * be copied to when hash constants have been patched.  
+	 */
+#ifdef CONFIG_APUS_FAST_EXCEPT
+	lis	r8,0xfff0
+#else
+	lis	r8,0
 #endif
+	ori	r8,r8,0x2		/* 128KB, supervisor */
+	mtspr	DBAT3U,r8
+	mtspr	DBAT3L,r8
+
+
+ 	APUS_PROGRESS(6)
+	isync				/* No speculative loading until now */
+	blr
+	
+apus_interrupt_entry:
+	/* This is horrible, but there's no way around it. Enable the
+	 * data cache so the IRQ hardware register can be accessed
+	 * without cache intervention. Then disable interrupts and get
+	 * the current emulated m68k IPL value. 
+	 */
+	
+	mfmsr	20
+	xori	r20,r20,MSR_DR
+	sync
+	mtmsr	r20
+	sync
+
+	lis	r4,APUS_IPL_EMU@h
+
+	li	r20,(IPLEMU_SETRESET|IPLEMU_DISABLEINT)
+	stb	r20,APUS_IPL_EMU@l(r4)
+	eieio
+
+	lbz	r3,APUS_IPL_EMU@l(r4)
+
+	li	r2,IPLEMU_IPLMASK
+	rlwinm. r20,r3,32-3,29,31
+	bne	2f
+	mr	r20,r2		/* lvl7! Need to reset state machine. */
+	b	3f
+2:	cmp	0,r20,r2
+	beq	1f
+3:	eieio
+	stb     r2,APUS_IPL_EMU@l(r4)
+	ori	r20,r20,IPLEMU_SETRESET
+	eieio
+	stb     r20,APUS_IPL_EMU@l(r4)
+1:	eieio
+	li	r20,IPLEMU_DISABLEINT
+	stb	r20,APUS_IPL_EMU@l(r4)
+
+	/* At this point we could do some magic to avoid the overhead
+	 * of calling the C interrupt handler. Could not get a simple
+	 * hack to work though.
+	 */
+	
+	mfmsr	r20
+	xori	r20,r20,MSR_DR
+	sync
+	mtmsr	r20
+	sync
+
+	stw	r3,(_CCR+4)(r21);
+
+	addi	r3,r1,STACK_FRAME_OVERHEAD;
+	li	r20,MSR_KERNEL;
+	bl	transfer_to_handler;
+	.long	do_IRQ;
+	.long	int_return
+	
+/***********************************************************************
+ *  Please note that on APUS the exception handlers are located at the
+ *  physical address 0xfff0000. For this reason, the exception handlers
+ *  cannot use relative branches to access the code below.
+ ***********************************************************************/
 
 #ifdef CONFIG_SMP
 	.globl	__secondary_start_psurge
@@ -1694,7 +1815,7 @@
 	/* our cpu # was at addr 0 - go */
 	lis	r5,__secondary_start@h
 	ori	r5,r5,__secondary_start@l
-	tophys(r5,r5,r4)
+	tophys(r5,r5)
 	mtlr	r5
 	mr	r24,r3			/* cpu # */
 	blr
@@ -1705,6 +1826,7 @@
  */
 start_here:
 #ifndef CONFIG_8xx
+ 	APUS_PROGRESS(7)
 	/*
 	 * Enable caches and 604-specific features if necessary.
 	 */
@@ -1783,6 +1905,7 @@
 /*
  * Decide what sort of machine this is and initialize the MMU.
  */
+ 	APUS_PROGRESS(8)
 	mr	r3,r31
 	mr	r4,r30
 	mr	r5,r29
@@ -1790,6 +1913,23 @@
 	mr	r7,r27
 	bl	identify_machine
 	bl	MMU_init
+ 	APUS_PROGRESS(9)
+
+	/* Copy exception code to exception vector base on APUS. */
+	bne	4,1f
+	lis	r4,KERNELBASE@h
+#ifdef CONFIG_APUS_FAST_EXCEPT
+	lis	r3,0xfff0		/* Copy to 0xfff00000 */
+#else
+	lis	r3,0			/* Copy to 0x00000000 */
+#endif
+	li	r5,0x4000		/* # bytes of memory to copy */
+	li	r6,0
+	bl	copy_and_flush		/* copy the first 0x4000 bytes */
+1:
+
+ 	APUS_PROGRESS(10)
+
 /*
  * Go back to running unmapped so we can load up new values
  * for SDR1 (hash table pointer) and the segment registers
@@ -1806,13 +1946,13 @@
 	 * easier......until someone changes init's static structures.
 	 */
 	lis	r6, swapper_pg_dir@h
-	tophys(r6,r6,0)
+	tophys(r6,r6)
 	ori	r6, r6, swapper_pg_dir@l
 	mtspr	M_TWB, r6
 #endif
 	lis	r4,2f@h
 	ori	r4,r4,2f@l
-	tophys(r4,r4,r3)
+	tophys(r4,r4)
 	li	r3,MSR_KERNEL & ~(MSR_IR|MSR_DR)
 	mtspr	SRR0,r4
 	mtspr	SRR1,r3
@@ -1843,7 +1983,7 @@
 	cmpwi	r3,1
 	lis	r3,BATS@ha
 	addi	r3,r3,BATS@l
-	tophys(r3,r3,r4)
+	tophys(r3,r3)
 	LOAD_BAT(0,0,r3,r4,r5)
 	LOAD_BAT(1,16,r3,r4,r5)
 	LOAD_BAT(2,32,r3,r4,r5)
@@ -1851,12 +1991,13 @@
 #endif /* CONFIG_8xx */
 /* Set up for using our exception vectors */
 	/* ptr to phys current tss */
-	tophys(r4,r2,r4)
+	tophys(r4,r2)
 	addi	r4,r4,TSS	/* init task's TSS */
 	mtspr	SPRG3,r4
 	li	r3,0
 	mtspr	SPRG2,r3	/* 0 => r1 has kernel sp */
 /* Now turn on the MMU for real! */
+ 	APUS_PROGRESS(12)
 	li	r4,MSR_KERNEL
 	lis	r3,start_kernel@h
 	ori	r3,r3,start_kernel@l
@@ -1866,7 +2007,7 @@
 	 */
 	lis	r5,first_cpu_booted@h
 	ori	r5,r5,first_cpu_booted@l
-	tophys(r5,r5,r3)
+	tophys(r5,r5)
 	lwz	r5,0(r5)
 	cmpi	0,r5,0
 	beq	10f
@@ -2066,7 +2207,7 @@
 	stw	r0,TRAP(r1)
 	stw	r1,KSP(r3)	/* Set old stack pointer */
 	sync
-	tophys(r0,r4,r3)
+	tophys(r0,r4)
 	mtspr	SPRG3,r0	/* Update current TSS phys addr */
 	SYNC
 	lwz	r1,KSP(r4)	/* Load new stack pointer */
@@ -2102,7 +2243,7 @@
 	beq+	10f		/* if not, don't adjust kernel stack */
 8:	addi	r4,r1,INT_FRAME_SIZE+STACK_UNDERHEAD	/* size of frame */
 	stw	r4,TSS+KSP(r2)	/* save kernel stack pointer */
-	tophys(r9,r1,r9)
+	tophys(r9,r1)
 	mtspr	SPRG2,r9	/* phys exception stack pointer */
 10:	lwz	r2,_CTR(r1)
 	lwz	r0,_LINK(r1)
@@ -2139,7 +2280,7 @@
 ret_from_syscall:	
 	.globl	int_return
 int_return:
-0:	mfmsr	r30		/* Disable interrupts */
+00:	mfmsr	r30		/* Disable interrupts */
 	li	r4,0
 	ori	r4,r4,MSR_EE
 	andc	r30,r30,r4
@@ -2177,7 +2318,7 @@
 	cmpi	0,r3,0		/* check need_resched flag */
 	beq+	7f
 	bl	schedule
-	b	0b
+	b	00b
 7:	lwz	r5,SIGPENDING(r2) /* Check for pending unblocked signals */
 	cmpwi	0,r5,0
 	beq+	8f
@@ -2186,10 +2327,10 @@
 	bl	do_signal
 	.globl	do_signal_ret
 do_signal_ret:
-	b	0b
+	b	00b
 8:	addi	r4,r1,INT_FRAME_SIZE+STACK_UNDERHEAD	/* size of frame */
 	stw	r4,TSS+KSP(r2)	/* save kernel stack pointer */
-	tophys(r3,r1,r3)
+	tophys(r3,r1)
 	mtspr	SPRG2,r3	/* phys exception stack pointer */
 10:	lwz	r2,_CTR(r1)
 	lwz	r0,_LINK(r1)
@@ -2339,14 +2480,14 @@
 	li	r4,4096/CACHE_LINE_SIZE	/* Number of lines in a page */
 	mtctr	r4
 	mr	r6,r3
-0:	dcbst	0,r3			/* Write line to ram */
+00:	dcbst	0,r3			/* Write line to ram */
 	addi	r3,r3,CACHE_LINE_SIZE
-	bdnz	0b
+	bdnz	00b
 	sync
 	mtctr	r4
-1:	icbi	0,r6
+10:	icbi	0,r6
 	addi	r6,r6,CACHE_LINE_SIZE
-	bdnz	1b
+	bdnz	10b
 	sync
 	isync
 	blr
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/irq.c ./arch/ppc/kernel/irq.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/irq.c	Tue May 11 11:26:17 1999
+++ ./arch/ppc/kernel/irq.c	Sun May 16 20:05:36 1999
@@ -61,6 +61,13 @@
 
 #include "local_irq.h"
 
+extern int  apus_request_irq(unsigned int irq, 
+                            void (*handler)(int, void *, struct pt_regs *),
+                            unsigned long flags, const char *devname, 
+                            void *dev_id);
+extern void apus_free_irq(unsigned int irq, void *dev_id);
+extern void apus_process_int(unsigned long, void *);
+
 extern volatile unsigned long ipi_count;
 void enable_irq(unsigned int irq_nr);
 void disable_irq(unsigned int irq_nr);
@@ -68,14 +75,6 @@
 /* Fixme - Need to figure out a way to get rid of this - Corey */
 volatile unsigned char *chrp_int_ack_special;
 
-#ifdef CONFIG_APUS
-/* Rename a few functions. Requires the CONFIG_APUS protection. */
-#define request_irq nop_ppc_request_irq
-#define free_irq nop_ppc_free_irq
-#define get_irq_list nop_get_irq_list
-#define VEC_SPUR    (24)
-#endif
-
 #define MAXCOUNT 10000000
 
 #define NR_MASK_WORDS	((NR_IRQS + 31) / 32)
@@ -133,6 +132,10 @@
 	struct irqaction *old, **p, *action;
 	unsigned long flags;
 
+	if (is_apus)
+		return apus_request_irq (irq, handler, irqflags, 
+					 devname, dev_id);
+
 	if (irq >= NR_IRQS)
 		return -EINVAL;
 	if (!handler)
@@ -187,7 +190,10 @@
 
 void free_irq(unsigned int irq, void *dev_id)
 {
-	request_irq(irq, NULL, 0, NULL, dev_id);
+	if (is_apus)
+		apus_free_irq (irq, dev_id);
+	else
+		request_irq(irq, NULL, 0, NULL, dev_id);
 }
 
 void disable_irq(unsigned int irq_nr)
@@ -205,6 +211,9 @@
 {
 	int i, len = 0, j;
 	struct irqaction * action;
+
+	if (_MACH_apus == _machine)
+		return apus_get_irq_list (buf);
 
 	len += sprintf(buf+len, "           ");
 	for (j=0; j<smp_num_cpus; j++)
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/misc.S ./arch/ppc/kernel/misc.S
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/misc.S	Tue May 11 11:26:19 1999
+++ ./arch/ppc/kernel/misc.S	Sat May 15 11:35:12 1999
@@ -243,10 +242,8 @@
 	subi	r5,r5,1		/* Perform 'add' operation */
 	stwcx.	r5,0,r3		/* Update with new value */
 	bne-	10b		/* Retry if "reservation" (i.e. lock) lost */
-	cmpi	0,r5,0		/* Return 'true' IFF 0 */
-	li	r3,1
-	beqlr
-	li	r3,0
+	cntlzw	r3,r5		/* Return 'true' IFF 0 */
+	srwi	r3,r3,5		/* But do it the clever way */
 	blr
 _GLOBAL(atomic_clear_mask)
 10:	lwarx	r5,0,r4
@@ -370,38 +367,59 @@
 	blr	
 
 /*
- * Extended precision shifts
+ * Extended precision shifts.
+ * 
+ * Updated to be valid for shift counts from 0 to 63 inclusive.
+ * -- Gabriel 
  *
  * R3/R4 has 64 bit value
  * R5    has shift count
  * result in R3/R4
  *
- *  ashrdi3:     XXXYYY/ZZZAAA -> SSSXXX/YYYZZZ
- *  ashldi3:     XXXYYY/ZZZAAA -> YYYZZZ/AAA000
+ *  ashrdi3: arithmetic right shift (sign propagation)     
+ *  lslhdi3: logical right shift	
+ *  ashldi3: left shift
  */
 _GLOBAL(__ashrdi3)
-	li	r6,32
-	sub	r6,r6,r5
-	slw	r7,r3,r6	/* isolate YYY */
-	srw	r4,r4,r5	/* isolate ZZZ */
-	or	r4,r4,r7	/* YYYZZZ */
-	sraw	r3,r3,r5	/* SSSXXX */
+	subfic	r6,r5,32	
+	srw	r4,r4,r5	# LSW = count > 31 ? 0 : LSW >> count
+	addi	r7,r5,32	# could be xori, or addi with -32
+	slw	r6,r3,r6	# t1 = count > 31 ? 0 :	MSW << (32-count)
+	rlwinm	r8,r7,0,32	# t3 = (count < 32) ? 32 : 0
+	sraw	r7,r3,r7	# t2 = MSW >> (count-32)
+	or	r4,r4,r6	# LSW |= t1
+	slw	r7,r7,r8	# t2 = (count < 32) ? 0 : t2
+	sraw	r3,r3,r5	# MSW = MSW >> count
+	or	r4,r4,r7	# LSW |= t2
 	blr
-	
+
 _GLOBAL(__ashldi3)
-	li	r6,32
-	sub	r6,r6,r5
-	srw	r7,r4,r6	/* isolate ZZZ */
-	slw	r4,r4,r5	/* AAA000 */
-	slw	r3,r3,r5	/* YYY--- */
-	or	r3,r3,r7	/* YYYZZZ */
+	subfic	r6,r5,32	
+	slw	r3,r3,r5	# MSW = count > 31 ? 0 : MSW << count
+	addi	r7,r5,32	# could be xori, or addi with -32
+	srw	r6,r4,r6	# t1 = count > 31 ? 0 :	LSW >> (32-count)
+	slw	r7,r4,r7	# t2 = count < 32 ? 0 :	LSW << (count-32)
+	or	r3,r3,r6	# MSW |= t1
+	slw	r4,r4,r5	# LSW = LSW << count
+	or	r3,r3,r7	# MSW |= t2
+	blr
+
+_GLOBAL(__lshrdi3)
+	subfic	r6,r5,32	
+	srw	r4,r4,r5	# LSW = count > 31 ? 0 : LSW >> count
+	addi	r7,r5,32	# could be xori, or addi with -32
+	slw	r6,r3,r6	# t1 = count > 31 ? 0 :	MSW << (32-count)
+	srw	r7,r3,r7	# t2 = count < 32 ? 0 :	MSW >> (count-32)
+	or	r4,r4,r6	# LSW |= t1
+	srw	r3,r3,r5	# MSW = MSW >> count
+	or	r4,r4,r7	# LSW |= t2 
 	blr
 
 _GLOBAL(abs)
-	cmpi	0,r3,0
-	bge	10f
-	neg	r3,r3
-10:	blr
+	srawi	r4,r3,31
+	xor	r3,r3,r4
+	sub	r3,r3,r4
+	blr
 
 _GLOBAL(_get_SP)
 	mr	r3,r1		/* Close enough */
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/pci.c ./arch/ppc/kernel/pci.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/pci.c	Tue May 11 11:26:20 1999
+++ ./arch/ppc/kernel/pci.c	Sat May 15 11:35:12 1999
@@ -60,6 +60,8 @@
 
 int pcibios_present(void)
 {
+	if (is_apus)
+		return 0;
 	return 1;
 }
 
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/pmac_setup.c ./arch/ppc/kernel/pmac_setup.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/pmac_setup.c	Wed May 12 09:56:47 1999
+++ ./arch/ppc/kernel/pmac_setup.c	Sun May 16 11:13:10 1999
@@ -54,6 +54,7 @@
 #include <asm/mediabay.h>
 #include <asm/feature.h>
 #include <asm/ide.h>
+#include <asm/dma.h>
 #include <asm/machdep.h>
 
 #include "time.h"
@@ -277,7 +278,7 @@
 
 	feature_init();
 
-#ifdef CONFIG_KGDB
+#if defined(CONFIG_KGDB) && defined(CONFIG_MAC_SERIAL)
 	zs_kgdb_hook(0);
 #endif
 
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/ppc-stub.c ./arch/ppc/kernel/ppc-stub.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/ppc-stub.c	Fri Aug  7 15:53:43 1998
+++ ./arch/ppc/kernel/ppc-stub.c	Sat Feb 20 16:32:45 1999
@@ -112,6 +112,32 @@
 #include <asm/pgtable.h>
 #include <asm/ptrace.h>
 
+#include <asm/io.h>
+#include <asm/amigahw.h>
+#include <asm/amigaints.h>
+
+extern int amiga_ser_out( unsigned char c );
+extern unsigned char amiga_ser_in( void );
+
+#define getDebugChar amiga_ser_in
+#define putDebugChar amiga_ser_out
+
+void kgdb_interruptible (int stat)
+{
+	if (stat) {
+		custom.intreq = IF_RBF;
+		mb();
+		custom.intena = IF_SETCLR | IF_RBF;
+	} else
+		custom.intena = IF_RBF;
+}
+
+void kgdb_abort (void)
+{
+	breakpoint ();
+}
+
+
 void breakinst(void);
 
 /*
@@ -181,7 +207,7 @@
  * return 0.
  */
 static unsigned char *
-mem2hex(char *mem, char *buf, int count)
+mem2hex(const char *mem, char *buf, int count)
 {
 	unsigned char ch;
 
@@ -343,7 +369,7 @@
 	flush_instruction_cache();
 }
 
-static inline int get_msr()
+static inline int get_msr(void)
 {
 	int msr;
 	asm volatile("mfmsr %0" : "=r" (msr):);
@@ -358,12 +384,23 @@
 /* Set up exception handlers for tracing and breakpoints
  * [could be called kgdb_init()]
  */
+
+void kgdb_init(void)
+{
+
+  set_debug_traps();
+}
+
+extern void amiga_serinit(void);
+
 void set_debug_traps(void)
 {
-#if 0
+
+#if 1
 	unsigned char c;
+	amiga_serinit();
 
-	save_and_cli(flags);
+/*	save_and_cli(flags);*/
 
 	/* In case GDB is started before us, ack any packets (presumably
 	 * "$?#xx") sitting there.
@@ -373,10 +410,12 @@
 	 * now starting either before or after the kernel   -bwb
 	 */
 
+#if 0
 	while((c = getDebugChar()) != '$');
 	while((c = getDebugChar()) != '#');
 	c = getDebugChar(); /* eat first csum byte */
 	c = getDebugChar(); /* eat second csum byte */
+#endif
 	putDebugChar('+'); /* ack it */
 #endif
 	debugger = kgdb;
@@ -701,4 +740,17 @@
 	asm("	.globl breakinst
 	     breakinst: trap
             ");
+}
+
+void
+__gdb_output_string (const char* s, unsigned int count)
+{
+	char buffer[512];
+
+	count = (count <= (sizeof(buffer) / 2 - 2)) 
+		? count : (sizeof(buffer) / 2 - 2);
+
+	buffer[0] = 'O';
+	mem2hex (s, &buffer[1], count);
+	putpacket(buffer);
 }
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/ppc_ksyms.c ./arch/ppc/kernel/ppc_ksyms.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/ppc_ksyms.c	Tue May 11 11:26:23 1999
+++ ./arch/ppc/kernel/ppc_ksyms.c	Sat May 15 12:29:33 1999
@@ -47,6 +47,7 @@
 extern int do_signal(sigset_t *, struct pt_regs *);
 
 asmlinkage long long __ashrdi3(long long, int);
+asmlinkage long long __lshrdi3(long long, int);
 asmlinkage int abs(int);
 
 EXPORT_SYMBOL(clear_page);
@@ -149,6 +150,7 @@
 EXPORT_SYMBOL(ioremap);
 EXPORT_SYMBOL(__ioremap);
 EXPORT_SYMBOL(iounmap);
+EXPORT_SYMBOL(iopa);
 
 EXPORT_SYMBOL(ide_insw);
 EXPORT_SYMBOL(ide_outsw);
@@ -200,19 +202,28 @@
 EXPORT_SYMBOL(find_path_device);
 EXPORT_SYMBOL(find_phandle);
 EXPORT_SYMBOL(get_property);
+EXPORT_SYMBOL(device_is_compatible);
+#ifdef CONFIG_PCI
 EXPORT_SYMBOL(pci_io_base);
 EXPORT_SYMBOL(pci_device_loc);
+#endif
 EXPORT_SYMBOL(feature_set);
 EXPORT_SYMBOL(feature_clear);
 EXPORT_SYMBOL(feature_test);
-#ifdef CONFIG_SCSI
+#if defined(CONFIG_SCSI) && defined(CONFIG_PMAC)
 EXPORT_SYMBOL(note_scsi_host);
-#endif
+#endif 
 EXPORT_SYMBOL(kd_mksound);
 #ifdef CONFIG_PMAC
 EXPORT_SYMBOL(nvram_read_byte);
 EXPORT_SYMBOL(nvram_write_byte);
 #endif /* CONFIG_PMAC */
+#ifdef CONFIG_APUS
+extern char debug_device[];
+EXPORT_SYMBOL(debug_device);
+extern unsigned long m68k_machtype;
+EXPORT_SYMBOL(m68k_machtype);
+#endif /* CONFIG_APUS */
 
 EXPORT_SYMBOL(abs);
 EXPORT_SYMBOL(device_is_compatible);
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/setup.c ./arch/ppc/kernel/setup.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/setup.c	Tue May 11 11:26:26 1999
+++ ./arch/ppc/kernel/setup.c	Sat May 15 18:35:05 1999
@@ -79,6 +79,7 @@
 int have_of = 0;
 int is_prep = 0;
 int is_chrp = 0;
+int is_apus = 0;
 /* For MTX/MVME boards.. with Raven/Falcon Chipset
       Real close to CHRP, but boot like PReP (via PPCbug)
       There's probably a nicer way to do this.. --Troy */
@@ -342,8 +343,8 @@
 	/* boot loader will tell us if we're APUS */
 	if ( r3 == 0x61707573 )
 	{
+		is_apus = 1;
 		_machine = _MACH_apus;
-		r3 = 0;
 	}
 	/* prep boot loader tells us if we're prep or not */
 	else if ( *(unsigned long *)(KERNELBASE) == (0xdeadc0de) ) {
@@ -397,6 +398,7 @@
 #elif defined(CONFIG_FADS)
 	_machine = _MACH_fads;
 #elif defined(CONFIG_APUS)
+	is_apus  = 1;
 	_machine = _MACH_apus;
 #else
 #error "Machine not defined correctly"
diff -u --recursive -B --exclude-from=/home/jskov/lib/diff-excludes -P /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/syscalls.c ./arch/ppc/kernel/syscalls.c
--- /home/jskov/kernel/dist/linux-2.2.8/arch/ppc/kernel/syscalls.c	Tue May 11 11:26:27 1999
+++ ./arch/ppc/kernel/syscalls.c	Sun May 16 10:19:38 1999
@@ -205,15 +205,12 @@
 
 	lock_kernel();
 	if (!(flags & MAP_ANONYMOUS)) {
-		file = fget(fd);
-		if (!file)
+		if (fd >= NR_OPEN || !(file = current->files->fd[fd]))
 			goto out;
 	}
 	
 	flags &= ~(MAP_EXECUTABLE | MAP_DENYWRITE);
 	ret = do_mmap(file, addr, len, prot, flags, offset);
-	if (file)
-		fput(file);
 out:
 	unlock_kernel();
 	return ret;
